var SERVER_PORT = 8080;
// var SERVER_IP = 'localhost';
var SERVER_IP = '0.0.0.0';

var express = require('express');
var http = require('http');

var main = express()
main.set('host', SERVER_IP);
main.set('port', SERVER_PORT);
var server = http.createServer(main)

var io  = require('socket.io').listen(server);
io.set('transports', ['websocket']);
server.listen(SERVER_PORT, SERVER_IP,  function() {
    console.log("Listening on port " + SERVER_PORT);
});

main.get('/', function(req, res){ res.sendFile(__dirname + '/under_construction.html'); });
main.get('/yalloo', function(req, res){ res.sendFile(__dirname + '/yalloo'); });
main.get('/session', function(req, res){ res.sendFile(__dirname + '/pages/client.html'); });
main.get('/session/client.js', function(req, res){ res.sendFile(__dirname + '/lib/client.js'); });


var channels = {};
var sockets = {};

io.sockets.on('connection', function (socket) {
    socket.channels = {};
    sockets[socket.id] = socket;

    console.log("["+ socket.id + "] connection accepted");
    socket.on('disconnect', function () {
        for (var channel in socket.channels) {
            leave(channel);
        }
        console.log("["+ socket.id + "] disconnected");
        delete sockets[socket.id];
    });


    socket.on('join', function (config) {
        console.log("["+ socket.id + "] joined ", config);
        var channel = config.channel;
        var userdata = config.userdata;

        if (channel in socket.channels) {
            console.log("["+ socket.id + "] ERROR: already joined ", channel);
            return;
        }

        if (!(channel in channels)) {
            channels[channel] = {};
        }

        for (id in channels[channel]) {
            channels[channel][id].emit('addUser', {'userId': socket.id, 'should_create_offer': false});
            socket.emit('addUser', {'userId': id, 'should_create_offer': true});
        }

        channels[channel][socket.id] = socket;
        socket.channels[channel] = channel;
    });

    function leave(channel) {
        console.log("["+ socket.id + "] left ");

        if (!(channel in socket.channels)) {
            console.log("["+ socket.id + "] ERROR: not in ", channel);
            return;
        }

        delete socket.channels[channel];
        delete channels[channel][socket.id];

        for (id in channels[channel]) {
            channels[channel][id].emit('removeUser', {'userId': socket.id});
            socket.emit('removeUser', {'userId': id});
        }
    }
    socket.on('leave', leave);

    socket.on('relayICECandidate', function(config) {
        var userId = config.userId;
        var iceCandidate = config.iceCandidate;
        console.log("["+ socket.id + "] relaying ICE candidate to [" + userId + "] ", iceCandidate);

        if (userId in sockets) {
            sockets[userId].emit('iceCandidate', {'userId': socket.id, 'iceCandidate': iceCandidate});
        }
    });

    socket.on('relaySessionDescription', function(config) {
        var userId = config.userId;
        var session_description = config.session_description;
        console.log("["+ socket.id + "] relaying session description to [" + userId + "] ", session_description);

        if (userId in sockets) {
            sockets[userId].emit('sessionDescription', {'userId': socket.id, 'session_description': session_description});
        }
    });
});
